#include <iostream>
#include <vector>
#include <functional>
#include <algorithm>
#include <numeric>
using namespace std;

const int MAXN = 200002;

struct avg
{
    long long sum, cnt;
    avg() : sum(0), cnt(0) {}
    avg(long long sum) : sum(sum), cnt(1) {}
    avg(long long sum, long long cnt) : sum(sum), cnt(cnt) {}
    auto operator>(const avg& o) const
    {
        return double(sum) / cnt > double(o.sum) / o.cnt;
    }
    auto operator>=(const avg& o) const
    {
        return double(sum) / cnt >= double(o.sum) / o.cnt;
    }
    auto operator+(const avg& o) const
    {
        return avg{sum + o.sum, cnt + o.cnt};
    }
    auto operator+=(const avg& o)
    {
        return *this = *this + o;
    }
    auto operator-(const avg& o) const
    {
        return avg{sum - o.sum, cnt - o.cnt};
    }
    auto operator-=(const avg& o)
    {
        return *this = *this - o;
    }
};

int n;
long long a[MAXN];
vector<long long> seq;
avg target, cur;

bool take(int &l, int &r, bool left, avg s)
{
    if (cur > target) return false;
    if ((s.cnt > 0 and s >= target) or l > r) return true;
    int i = left ? l : r;
    cur -= a[i];
    if (left) l++;
    else r--;
    bool ok = take(l, r, left, s + a[i]);
    if (ok) seq.push_back(i);
    else
    {
        cur += a[i];
        if (left) l--;
        else r++;
    }
    return ok;
};

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    long long sum = 0;
    for (int i = 0; i < n; ++ i)
    {
        cin >> a[i];
        sum += a[i];
    }

    target.sum = sum;
    target.cnt = n;
    cur = target;

    int l = 0, r = n - 1;
    bool left = true;
    while (l <= r)
    {
        auto last = seq.size();
        if (take(l, r, left, avg())) reverse(seq.begin() + last, seq.end());
        else if (take(l, r, !left, avg()))
        {
            reverse(seq.begin() + last, seq.end());
            left = !left;
        }
        else
        {
            cout << "impossible\n";
            return 0;
        }
    }
    reverse(seq.begin(), seq.end());
    for (int i = 0; i < n; ++ i)
    {
        cout << seq[i]+1 << ' ';
    }

    cout << endl;
    return 0;
}
